storyscene function MakeFollower( player: CStoryScenePlayer, active: bool, npc : CName, fact : CName )
{
	var l_actor : CActor;
	
	l_actor = theGame.GetNPCByTag( npc );
	
	// B&W Hack
	if(!l_actor) {
		if(npc == 'cirilla') {
			thePlayer.SetPermanentFollower('cirilla', "quests\main_npcs\cirilla.w2ent");
			thePlayer.PermanentFollowers(0, 0);
			thePlayer.CheckDuplicateFollowers(0, 0);
			FactsAdd('ciri_dd_start', 1, -1);
			ApplyAppearance('cirilla', 'ciri');
		}
		if(npc == 'triss') {
			thePlayer.SetPermanentFollower('triss', "quests\main_npcs\triss.w2ent");
			thePlayer.PermanentFollowers(0, 0);	
			thePlayer.CheckDuplicateFollowers(0, 0);
			FactsAdd('triss_dd_start', 1, -1);
		}
		if(npc == 'yennefer') {
			thePlayer.SetPermanentFollower('yennefer', "quests\main_npcs\yennefer.w2ent");
			thePlayer.PermanentFollowers(0, 0);	
			thePlayer.CheckDuplicateFollowers(0, 0);
			FactsAdd('yennefer_dd_start', 1, -1);
			ApplyAppearance('yennefer', 'yennefer_travel_outfit');
		}
	}
	
	LogChannel('FOLLOWER', "MakeFollower "  + l_actor + ", active: " + active + ", npc: " + npc + ", fact: " + fact);
	
	
	if(active) {
		FactsAdd(fact, 1, -1);
		thePlayer.SetPermanentFollower(npc, l_actor.GetReadableName());
		thePlayer.SetFollowerDelayed(l_actor);
		if(npc == 'cirilla') {ApplyAppearance('cirilla', 'ciri');}
		if(npc == 'yennefer') {ApplyAppearance('yennefer', 'yennefer_travel_outfit');}
	}
	else {
		FactsRemove(fact);		
		thePlayer.StopPermanentFollower(npc);
		thePlayer.StopFollower(l_actor);
		if(npc == 'cirilla') {ApplyAppearance('cirilla', 'ciri');}
		if(npc == 'yennefer') {ApplyAppearance('yennefer', 'yennefer_travel_outfit');}
	}
}


exec function ciriFollower()
{
	thePlayer.StopPermanentFollower('cirilla');
	thePlayer.SetPermanentFollower('cirilla', "quests\main_npcs\cirilla.w2ent");
	thePlayer.PermanentFollowers(0, 0);	
	FactsAdd('ciri_dd_start', 1, -1);
	FactsAdd('mod_cirilla_active_follower', 1, -1);
	ApplyAppearance('cirilla', 'ciri');
}

exec function trissFollower()
{
	thePlayer.StopPermanentFollower('triss');
	thePlayer.SetPermanentFollower('triss', "quests\main_npcs\triss.w2ent");
	thePlayer.PermanentFollowers(0, 0);	
	FactsAdd('triss_dd_start', 1, -1);
	FactsAdd('mod_triss_active_follower', 1, -1);
}

exec function yenneferFollower()
{
	thePlayer.StopPermanentFollower('yennefer');
	thePlayer.SetPermanentFollower('yennefer', "quests\main_npcs\yennefer.w2ent");
	thePlayer.PermanentFollowers(0, 0);	
	FactsAdd('yennefer_dd_start', 1, -1);
	FactsAdd('mod_yennefer_active_follower', 1, -1);
	ApplyAppearance('yennefer', 'yennefer_travel_outfit');
}

exec function questYennefer()
{
	var l_actor : CActor;
	var template :CEntityTemplate;
	var pos : Vector;
	var rot : EulerAngles;
	var taglist : array<CName>;
	
	template = (CEntityTemplate)LoadResource("quests\main_npcs\yennefer.w2ent", true);
	pos = thePlayer.GetWorldPosition() + VecRingRand(1.f,2.f);
	rot = VecToRotation(thePlayer.GetWorldPosition() - pos);
	
	taglist.PushBack('YENNEFER');
	taglist.PushBack('vip');
	taglist.PushBack('yennefer');
	
	l_actor = (CActor)theGame.CreateEntity(template, pos, rot , true, false, false, PM_Persist, taglist);
	l_actor.GetComponent('talk').SetEnabled(true);
}

exec function followMe()
{
	thePlayer.SetFollower(thePlayer.GetTarget());
}

exec function stopFollowingMe()
{
	thePlayer.StopFollower(thePlayer.GetTarget());
}